<?php

namespace Oro\Bundle\CatalogBundle\Migrations\Schema\v1_15_1;

use Doctrine\DBAL\Schema\Schema;
use Oro\Bundle\CatalogBundle\Entity\Category;
use Oro\Bundle\EntityConfigBundle\Migration\UpdateEntityConfigFieldValueQuery;
use Oro\Bundle\MigrationBundle\Migration\Migration;
use Oro\Bundle\MigrationBundle\Migration\QueryBag;

/**
 * Updates acl_protected entity field config option for longDescriptions field of Category entity.
 */
class UpdateAttachmentFieldConfigForLongDescriptions implements Migration
{
    /**
     * {@inheritdoc}
     */
    public function up(Schema $schema, QueryBag $queries)
    {
        $queries->addPostQuery(
            new UpdateEntityConfigFieldValueQuery(
                Category::class,
                'longDescriptions',
                'attachment',
                'acl_protected',
                false
            )
        );
    }
}
